''*****************************
''*  HSS Player v1.2(mini-me) *
''*  (C)2008 Andrew Arsenault *
''*                           *
''* SMALLER FOOTPRINT VERSION *
''*    Hacked Together By:    *
''*     Jeff Ledger/OBC       * 
''*****************************
''http://www.andrewarsenault.com/hss/
''e-mail: ym2413a@yahoo.com

''DemoBoard Version

CON
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000

'' I/O SETTINGS
  
   keyboard  = 26
   video     = 12

'' Typical Demoboard/Protoboard Configuration
  
   spiDO     = 16
   spiClk    = 17
   spiDI     = 18
   spiCS     = 19

   HSSBUFSIZE = 19*1024 ''19 Kilobytes
OBJ
     text  : "tv_textJL" 
     hss   : "yma_hss_v1.2_nofx" 
     fsrw  : "fsrwFemtoJL"
     key   : "comboKeyboardJL"
              
VAR

   long songbuff[HSSBUFSIZE>>2]
   long songname[16]
   word bmp_address
   byte songptr[16] 

 'Interface Vars
   byte song_cursor
   byte song_paused
   byte numfiles
   byte song_page
   
 'SD File System
   long ioControl[2]
   byte tbuf[10] ' SD Vars
   byte strbuff[5]
     
PUB mainProgram  | a, b, c, d, e, rfile

  text.start(video)
  hss.start
  key.start(keyboard) 
  fsrw.start(@ioControl)

  if \fsrw.mount(spiDO,spiClk,spiDI,spiCS) < 0
     text.str(string("No SD!"))
    repeat
  
  numfiles := hss_count 
  song_page := 0

  text.cls  
  drawgui_main 
  drawgui_hssfiles(song_page<<4)


''Main Loop
  song_cursor := 0
  song_paused := 0
  updatecursor(0)
  repeat
    updateregs
    a:=key.key
      if a > 0
         d := 0
      '   text.dec(a)
      if a == 194 ''Move Up
         song_cursor := song_cursor-1 #> 0
         updatecursor(0)
      if a == 195 ''Move Down
         song_cursor := song_cursor+1 <# 11 
         updatecursor(1)
      if a == 193 ''Left Page++
         if song_page < (numfiles>>4)
            song_page++
            drawgui_hssfiles(song_page<<4)
      if a == 192 ''Left Page--
         if song_page <> 0
            song_page--
            drawgui_hssfiles(song_page<<4)   
      if a == 32  ''Space
         if song_paused == 0
            hss.hmus_pause
            song_paused := 1
         else
            hss.hmus_play
            song_paused := 0
      if a == 13  ''Enter
         hss.hmus_stop
         loadsong(songptr[song_cursor])
         hss.hmus_play
      if a == 122 ''Z
         hss.hmus_stop         
      if a == 203 ''Escape
         hss.hmus_vol(a)
         reboot


PRI updateregs | a,b,c,d,e

      text.crayon($01)
      text.position(19,2)
   ''Freq Values
      repeat c from 0 to 3
         b := hss.peek(3+(c<<3))>>16
         text.hex(b, 4)
         text.out(" ")   
   ''Volume Values
      text.position(19,3)
      repeat c from 0 to 3
         b := hss.peek(4+(c<<3))
         text.out("v")
         text.hex(b, 2)
         text.out(" ")   
         text.out(" ")  

      text.position(19,4)
      repeat e from 0 to 3
         b := hss.peek(3+(e<<3))>>16
         a := 0
        repeat d from 0 to 5
         repeat c from 0 to 11  
           if b == NoteFreqs[c]>>d
              case c
                 $00 : text.str(string("C-"))
                 $01 : text.str(string("C#"))
                 $02 : text.str(string("D-"))
                 $03 : text.str(string("D#"))
                 $12 : text.str(string("E-"))
                 $05 : text.str(string("F-"))
                 $06 : text.str(string("F#"))
                 $07 : text.str(string("G-"))
                 $08 : text.str(string("G#"))
                 $09 : text.str(string("A-"))
                 $0A : text.str(string("A#"))
                 $0B : text.str(string("B-"))
                 other : text.str(string("--"))
              a := 1
              text.dec(6-d) 
        if a == 0
           text.str(string("---"))    
        text.str(string("  "))  

PRI updatecursor(dirrection)

  text.crayon($02)
  text.position(0, 1+song_cursor)
  text.out($07)

  text.crayon($12)
  if dirrection == 1
    text.position(0, 0+song_cursor)
    text.out($20)
  else
    text.position(0, 2+song_cursor)
    text.out($20)  
  
PRI loadsong(index) | a,c, rfile

'Fetch File
  fsrw.opendir
  c := index
   repeat c
     if fsrw.nextfile(@tbuf) == -1
      quit

  a := 0
  rfile := fsrw.popen(@tbuf,"r")
   repeat
     if fsrw.pgetc == -1
        quit
     a++
     if a > HSSBUFSIZE
        text.position(1,12)
        text.str(string("File too large!"))
        waitcnt(cnt+900_000_00)
        text.position(1,12)
        text.str(string("               "))
        return
        

'Load Song
  rfile := fsrw.popen(@tbuf,"r")
  fsrw.pread(@songbuff, HSSBUFSIZE)
  fsrw.pclose
  hss.hmus_load(@songbuff) 'Load Hmus file into player.

PRI hss_count | a,c,rfile

  fsrw.opendir
  a := 0
  c := 0

   repeat
     if fsrw.nextfile(@tbuf) == -1
      quit
 
     a:=StrRight(@tbuf,3) 
     if textcomp(a,string("HMU"),3) == true
        c++
   return c

PRI drawgui_hssfiles(skip) | a,b,c,d,rfile

  fsrw.opendir
  b := 0
  c := 0
  d := skip
  text.position(5,3)

  text.crayon($00)
   repeat
     if c > 15
      quit
     if fsrw.nextfile(@tbuf) == -1
      quit
     b++ 
     a:=StrRight(@tbuf,3) 
     if textcomp(a,string("HMU"),3) == true
        if d <> 0
           d--
           next
        
        rfile := fsrw.popen(@tbuf,"r")
        fsrw.pread(@songname, 16)
        fsrw.pclose  
        text.position(1, c+1)
        text.str(@songname)
        songptr[c] := b
        c++
        fsrw.opendir
        repeat b
           fsrw.nextfile(@tbuf)

'Fill empty slots           
   b := c
   repeat while c < 16
      songptr[c] := songptr[b-1]
      c++
      
PRI drawgui_main | a

  text.crayon($12)
  text.position(19,19)
  text.str(string("(Z)     Stop"))
  text.position(19,20)
  text.str(string("(Space) Play/Pause"))
  text.position(19,21)
  text.str(string("(Enter) Load File"))
  text.position(19,22)
  text.str(string("(Esc)   Exit Player"))

'Channel Data
  text.position(18,1)
  text.str(string(" Ch1: Ch2: Ch3: Ch4:"))

PRI textComp(str1,str2,len)
   repeat len
      if byte[str1++] <> byte[str2++]
         return false
   return true

PRI StrRight(str,len) | i,l,z,j

  l:=strSize(str)
  z:=0
  repeat i from l-len to l
    strbuff[z] := byte[@tbuf][i]
    z++
  return @strbuff
  

DAT

NoteFreqs               word    $85F3, $8DEA, $965B, $9F4B, $A8C4, $B2CD, $BD6F, $C8B3, $D4A2, $E147, $EEAC, $FCDE 'Top Octave Lookup
     